import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A bullet that can hit zombies.
 * 
 * @author Poul Henriksen
 * @author Michael Kölling
 * 
 * @version 2.0
 */
public class Bullet extends Mover
{
    /** A bullet looses one life each act, and will disappear when life = 0 */
    private int life = 58;
    
    /** The damage this bullet will deal */
    private int damage = 13;
    
    public Bullet()
    {
    }
    
    public Bullet(Vector speed, int rotation)
    {
        super(speed);
        setRotation(rotation);
        increaseSpeed(new Vector(rotation, 15));
        Greenfoot.playSound("rifle_shot.wav");
    }
    
    /**
     * The bullet will damage zombie if it hits them.
     */
    public void act()
    {
        if(life <= 0) {
            getWorld().removeObject(this);
        } 
        else {
            move();
            Zombie zombie = (Zombie) getOneIntersectingObject(Zombie.class);
            if (zombie != null) 
            {
                getWorld().removeObject(this);
                zombie.hit(damage);
            }
            else {
                life--;
            }
        }
    }
}