import greenfoot.*;

/**
 * Write a description of class Soldier here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Soldier extends Mover
{
    //Global Variables for the Soldier Class
    private int gunReloadTime;
    private int reloadDelayCount;
    private int shotsFired;
    private Vector acceleration;
    public int stability;
    private GreenfootImage image1;
    private GreenfootImage image2;
    //deadZombies is used to count how many Zombies are killed "drafted by Jared Oliverio"
    static public int deadZombies;

    /**
     * Start this soldier with the following attributes
     */
    public Soldier()
    {
        gunReloadTime = 15;
        reloadDelayCount = 0;
        shotsFired = 0;
        stability = 100;
        deadZombies = 0;
        image1 = new GreenfootImage("soldier.png");
        image2 = new GreenfootImage("soldierReload.png");
    }
    
    /**
     * Act - do whatever the Soldier wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkKeys();
        reloadDelayCount++;
        emptyMag();
    }
    
    /**
     * Set the time needed for re-loading the soldiers gun. The shorter the time, the faster the
     * rifle fires.
     */
    public void setGunReloadTime(int reloadTime)
    {
        gunReloadTime = reloadTime;
    }
    
    /**
     * Fire bullet if the gun is ready.
     */
    private void fire()
    {
        if (reloadDelayCount >= gunReloadTime)
        {
            Bullet b = new Bullet(getMovement().copy(), getRotation());
            getWorld().addObject(b, 200, 537);
            b.move();
            shotsFired = shotsFired + 1;
            reloadDelayCount = 0;
        }
    }
    
    /**
     * Return the number of shots fired from this Soldier.
     */
    public int getShotsfired()
    {
        return shotsFired;
    }
    
    /**
     * Check to see which key is pressed and determine the action it performs
     */
    private void checkKeys()
    {
        if(Greenfoot.isKeyDown("space"))
        fire();
        if(Greenfoot.isKeyDown("r"))
        {
        reload();
        setImage(image1);
        }
    }
    
    /**
     * Method that controls reloading your weapon
     */
    public void emptyMag()
    {
        if(shotsFired == 30)
        {
            gunReloadTime = 400;
            setImage(image2);
        }
    }
    
    /**
     * Reload your Weapon
     */
    public void reload()
    {
        gunReloadTime = 15;
        shotsFired = 0;
    }
}
